# Test cases for Homework 9 - Fall 2023
#-------------------------------------------------------------------------------------------
import autotester_base
from autotester_base import Lit, opts

def testall(start=None, mode='brief', clear=True):
   autotester_base.test_target_list(_target_list, _test_cases, start, mode, clear)

def test(fun_or_name, cases=None, mode=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, mode, alias, input, _test_cases)

def vtest(fun_or_name, cases=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, 'verbose', alias, input, _test_cases)

#-------------------------------------------------------------------------------------------

_target_list = [
   # Lab 9
   'inBounds', 'searchDirection', 'searchFromPosition', 'searchGrid', 'findwords',
   # (no test cases for playTTT)
   # zipcode database functions:
   'milesBetween', 'samePlace', 'allZips',
   # extra credit:
   'neighbors', 'closest', 'nearby',
   ]

#------------------------------------------------------------------------------------------------
# auxiliary functions

_grid1 = [['c', 'a', 't', 'n', 'x', 'f'],
          ['k', 'c', 'o', 'r', 'e', 'r'],
          ['d', 'i', 'o', 'k', 'c', 'o'],
          ['l', 'r', 'a', 'w', 'i', 'g'],
          ['d', 'n', 'i', 'l', 'm', 'i'],
          ['s', 'o', 'w', 'b', 'l', 'p'],
          ['n', 'o', 'g', 'a', 'r', 'd']]

def _makedb(filename):
    f = open(filename, "r")
    allLines = f.readlines()
    f.close()
    database = {}
    for line in allLines:
        zipcode,latitude,longitude,city,county,state,pop = line.strip().split(",")
        latitude,longitude,pop = eval(latitude),eval(longitude),eval(pop)
        record = {'city':city, 'state':state, 'zip': zipcode,
                  'county':county, 'pop':pop, 'coords':[latitude,longitude]}
        database[zipcode] = record
    return database

_db = _makedb("zipDataAll.txt")

# necessary because cities could be output in any order.
# also makes sure that output contains no duplicate lines.
def _make_verifier(expectedLines):
   def verifier(output):
      if _has_duplicates(output.split('\n')):
         return 'output contains duplicates'
      output = output.lower()
      for line in expectedLines:
         if line.lower() not in output:
            return 'should have printed \"%s\"' % line
      return True
   return verifier

def _has_duplicates(vals):
   for x in vals:
      if vals.count(x) > 1:
         return True
   return False

#------------------------------------------------------------------------------------------------

_test_cases = {
   'inBounds':{
      1: ('', (5, 0, _grid1), True),
      2: ('', (7, 1, _grid1), False),
      3: ('', (5, -1, _grid1), False),
      4: ('', (6, 5, _grid1), True),
      5: ('', (7, 5, _grid1), False),
      6: ('', (6, 6, _grid1), False),
      7: ('', (0, 0, _grid1), True),
      8: ('', (-1, 0, _grid1), False),
      9: ('', (0, -1, _grid1), False),
      10: ('', (-2, 8, _grid1), False),
   },
   'searchDirection':{
      1: ('', ('frog', 0, 5, 'down', _grid1), True,
          'frog', 'found', ('0, 5','0,5','0 5'), 'down'),
      2: ('', ('frog', 0, 5, 'right', _grid1), False),
      3: ('', ('froggy', 0, 5, 'down', _grid1), False),
      4: ('', ('cow', 2, 4, 'right', _grid1), False),
      5: ('', ('dragon', 6, 5, 'left', _grid1), True,
          'dragon', 'found', ('6, 5','6,5','6 5'), 'left'),
      6: ('', ('dragon', 6, 5, 'up', _grid1), False),
      7: ('', ('cow', 1, 1, 'right', _grid1), False),
      8: ('', ('cow', 1, 1, 'down right', _grid1), True,
          'cow', 'found', ('1, 1','1,1','1 1'), 'down right'),
      9: ('', ('snake', 5, 0, 'up right', _grid1), True,
          'snake', 'found', ('5, 0','5,0','5 0'), 'up right'),
      10: ('', ('snakefest', 5, 0, 'up right', _grid1), False),
   },
   'searchFromPosition':{
      1: ('', ('frog', 0, 5, _grid1), True, 'frog', 'found', ('0, 5','0,5','0 5'), 'down'),
      2: ('', ('cow', 1, 1, _grid1), True, 'cow', 'found', ('1, 1','1,1','1 1'), 'right'),
      3: ('', ('cow', 0, 0, _grid1), False),
      4: ('', ('cow', 2, 4, _grid1), False),
      5: ('', ('dragon', 6, 5, _grid1), True, 'dragon', 'found', ('6, 5','6,5','6 5'), 'left'),
      6: ('', ('dragon', 6, 0, _grid1), False),
      7: ('', ('owl', 6, 1, _grid1), True, 'owl', 'found', ('6, 1','6,1','6 1'), 'up right'),
      8: ('', ('snake', 5, 0, _grid1), True, 'snake', 'found', ('5, 0','5,0','5 0'), 'up right'),
      9: ('', ('rock', 1, 3, _grid1), True, 'rock', 'found', ('1, 3','1,3','1 3'), 'left'),
      10: ('', ('mice', 4, 4, _grid1), True, 'mice', 'found', ('4, 4','4,4','4 4'), 'up'),
   },
   'searchGrid':{
      1: ('', ('frog', _grid1), True, 'frog', 'found', ('0, 5','0,5','0 5'), 'down'),
      2: ('', ('cow', _grid1), True, 'cow', 'found', ('1, 1','1,1','1 1'), 'right'),
      3: ('', ('dragon', _grid1), True, 'dragon', 'found', ('6, 5','6,5','6 5'), 'left'),
      4: ('', ('owl', _grid1), True, 'owl', 'found', ('6, 1','6,1','6 1'), 'up right'),
      5: ('', ('snake', _grid1), True, 'snake', 'found', ('5, 0','5,0','5 0'), 'up right'),
      6: ('', ('rock', _grid1), True, 'rock', 'found', ('1, 3','1,3','1 3'), 'left'),
      7: ('', ('mice', _grid1), True, 'mice', 'found', ('4, 4','4,4','4 4'), 'up'),
      8: ('', ('puppy', _grid1), False),
      9: ('', ('froggy', _grid1), False),
      10: ('', ('cats', _grid1), False),
   },
   'findwords':{
      1: ('frog\ncow\ndragon\nowl\nsnake\nquit', ('grid1.txt',), None,
          'frog found', ('0, 5','0,5','0 5'), 'down',
          'cow found', ('1, 1','1,1','1 1'), 'right',
          'dragon found', ('6, 5','6,5','6 5'), 'left',
          'owl found', ('6, 1','6,1','6 1'), 'up right',
          'snake found', ('5, 0','5,0','5 0'), 'up right'),
      2: ('puppy\nquit', ('grid1.txt',), None,
          'not found'),
      3: ('froggy\nquit', ('grid1.txt',), None,
          'not found'),
      4: ('lion\npig\nbird\nquit', ('grid1.txt',), None,
          'lion found', ('3, 0', '3,0', '3 0'), 'up right',
          'pig found', ('5, 5', '5,5', '5 5'), 'up',
          'bird found', ('5, 3', '5,3', '5 3'), 'up left'),
   },
   'milesBetween':{
      1: ('10708\n10001', (_db,), None,
          Lit('Bronxville, NY 10708'),
          Lit('New York, NY 10001'),
          '15.6 miles apart'),
      2: ('90210\n12345', (_db,), None,
          Lit('Beverly Hills, CA 90210'),
          Lit('Schenectady, NY 12345'),
          '2451.3 miles apart'),
      3: ('99701\n33330', (_db,), None,
          Lit('Fairbanks, AK 99701'),
          Lit('Fort Lauderdale, FL 33330'),
          ('3935.0 miles apart', '3935 miles apart')),
      4: ('55555\n22222', (_db,), None,
          Lit('Young America, MN 55555'),
          Lit('Arlington, VA 22222'),
          ('952.0 miles apart', '952 miles apart')),
      },
   'samePlace':{
      1: ('', ('10003', '10035', _db), True),
      2: ('', ('10701', '10708', _db), False),
      3: ('', ('10601', '23893', _db), False),
      4: ('', ('10001', '10001', _db), True),
      5: ('', ('90001', '90039', _db), True),
      6: ('', ('62701', '01138', _db), False),
      },
   'allZips':{
      1: ('Yonkers, NY', (_db,), None, Lit('Yonkers, NY'), '10710', '6', 'found'),
      2: ('New York, NY', (_db,), None, Lit('New York, NY'), '10072', '162', 'found'),
      3: ('Los Angeles, CA', (_db,), None, Lit('Los Angeles, CA'), '90081', '99', 'found'),
      4: ('White Plains, NY', (_db,), None, Lit('White Plains, NY'), '10610', '11', 'found'),
      5: ('Fort Sill, OK', (_db,), None, Lit('Fort Sill, OK'), '73503', '1', 'found'),
      },
   'neighbors':{
      1: ('10701', (_db,), None, _make_verifier([
         'Mount Vernon, NY 10550 is 3.0 miles away',
         'Hastings On Hudson, NY 10706 is 2.9 miles away',
         'Tuckahoe, NY 10707 is 2.8 miles away',
         'Bronxville, NY 10708 is 2.0 miles away',
         'Eastchester, NY 10709 is 2.9 miles away',
         ])),
      2: ('10003', (_db,), None, _make_verifier([
         'Hoboken, NJ 07030 is 2.6 miles away',
         'Jersey City, NJ 07310 is 2.6 miles away',
         'Long Island City, NY 11101 is 3.0 miles away',
         'Brooklyn, NY 11201 is 2.5 miles away',
         'Brooklyn, NY 11206 is 2.9 miles away',
         'Brooklyn, NY 11211 is 2.7 miles away',
         'Brooklyn, NY 11222 is 2.2 miles away',
         ])),
      3: ('73501', (_db,), None, _make_verifier([
         'Fort Sill, OK 73503 is 2.1 miles away',
         'Elgin, OK 73538 is 3.0 miles away',
         'Faxon, OK 73540 is 0.6 miles away',
         'Medicine Park, OK 73557 is 0.6 miles away',
         'Meers, OK 73558 is 0.6 miles away',
         ])),
      4: ('82010', (_db,), None, _make_verifier([
         'No neighboring cities or towns',
         ])),
      5: ('87901', (_db,), None, _make_verifier([
         'No neighboring cities or towns',
         ])),
      },
   'closest':{
      1: ('Bronxville, NY', (_db,), None, 'Yonkers, NY'),
      2: ('New York, NY', (_db,), None, 'Jersey City, NJ'),
      3: ('Kansas City, KS', (_db,), None, 'Kansas City, MO'),
      4: ('Kansas City, MO', (_db,), None, 'Kansas City, KS'),
      5: ('Truth Or Consequences, NM', (_db,), None, 'El Paso, TX'),
      6: ('Lawton, OK', (_db,), None, 'Wichita Falls, TX'),
      7: ('Annandale, VA', (_db,), None, 'Alexandria, VA'),
      8: ('Los Angeles, CA', (_db,), None, 'Downey, CA'),
      },
   'nearby':{
      1: ('Lawton, OK\n100\n25000', (_db,), None, _make_verifier([
               'Oklahoma City, OK',
               'Edmond, OK',
               'Shawnee, OK',
               'Norman, OK',
               'Wichita Falls, TX',
               ])),
      2: ('Lawton, OK\n100\n750000', (_db,), None, _make_verifier([
               'None found',
               ])),
      3: ('Lawton, OK\n125\n25000', (_db,), None, _make_verifier([
               'Oklahoma City, OK',
               'Denton, TX',
               'Norman, OK',
               'Wichita Falls, TX',
               'Carrollton, TX',
               'Edmond, OK',
               'Sherman, TX',
               'Shawnee, OK',
               'Lewisville, TX',
               'Flower Mound, TX',
               ])),
      4: ('Lawton, OK\n500\n600000', (_db,), None, _make_verifier([
               'Austin, TX',
               'Dallas, TX',
               'Houston, TX',
               'Memphis, TN',
               'San Antonio, TX',
               ])),
      5: ('Dallas, TX\n50\n250000', (_db,), None, _make_verifier([
               'Fort Worth, TX',
               'Arlington, TX',
               ])),
      6: ('Dallas, TX\n50\n600000', (_db,), None, _make_verifier([
               'None found'
               ])),
      },

   }
